From 6999ab7e20f4cbe3854ce2678673cb070b9ba75f Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Thu, 16 Jun 2022 01:58:28 +0100
Subject: [PATCH 05/21] Remove pyspotify: search

---
 mopidy_spotify/library.py |  1 -
 mopidy_spotify/search.py  |  7 +++----
 tests/test_search.py      | 16 +++++++---------
 3 files changed, 10 insertions(+), 14 deletions(-)

diff --git a/mopidy_spotify/library.py b/mopidy_spotify/library.py
index 06ae7757..05ca19ac 100644
--- a/mopidy_spotify/library.py
+++ b/mopidy_spotify/library.py
@@ -40,7 +40,6 @@ def lookup(self, uri):
     def search(self, query=None, uris=None, exact=False):
         return search.search(
             self._config,
-            self._backend._session,
             self._backend._web_client,
             query,
             uris,
diff --git a/mopidy_spotify/search.py b/mopidy_spotify/search.py
index 7e940e6e..74413a17 100644
--- a/mopidy_spotify/search.py
+++ b/mopidy_spotify/search.py
@@ -13,7 +13,6 @@
 
 def search(
     config,
-    session,
     web_client,
     query=None,
     uris=None,
@@ -27,7 +26,7 @@ def search(
         return models.SearchResult(uri="spotify:search")
 
     if "uri" in query:
-        return _search_by_uri(config, session, web_client, query)
+        return _search_by_uri(config, web_client, query)
 
     sp_query = translator.sp_search_query(query, exact)
     if not sp_query:
@@ -37,7 +36,7 @@ def search(
     uri = f"spotify:search:{urllib.parse.quote(sp_query)}"
     logger.info(f"Searching Spotify for: {sp_query}")
 
-    if session.connection.state is not spotify.ConnectionState.LOGGED_IN:
+    if web_client is None or not web_client.logged_in:
         logger.info("Spotify search aborted: Spotify is offline")
         return models.SearchResult(uri=uri)
 
@@ -107,7 +106,7 @@ def search(
     )
 
 
-def _search_by_uri(config, session, web_client, query):
+def _search_by_uri(config, web_client, query):
     tracks = []
     for uri in query["uri"]:
         tracks += lookup.lookup(config, web_client, uri)
diff --git a/tests/test_search.py b/tests/test_search.py
index 6bca63e9..7328fc16 100644
--- a/tests/test_search.py
+++ b/tests/test_search.py
@@ -1,6 +1,5 @@
 from mopidy import models
 
-import spotify
 from mopidy_spotify import search
 
 
@@ -22,8 +21,8 @@ def test_search_with_empty_query_returns_nothing(provider, caplog):
     assert "Ignored search with empty query" in caplog.text
 
 
-def test_search_by_single_uri(session_mock, sp_track_mock, provider):
-    session_mock.get_link.return_value = sp_track_mock.link
+def test_search_by_single_uri(web_client_mock, web_track_mock, provider):
+    web_client_mock.get_track.return_value = web_track_mock
 
     result = provider.search({"uri": ["spotify:track:abc"]})
 
@@ -36,8 +35,8 @@ def test_search_by_single_uri(session_mock, sp_track_mock, provider):
     assert track.bitrate == 160
 
 
-def test_search_by_multiple_uris(session_mock, sp_track_mock, provider):
-    session_mock.get_link.return_value = sp_track_mock.link
+def test_search_by_multiple_uris(web_client_mock, web_track_mock, provider):
+    web_client_mock.get_track.return_value = web_track_mock
 
     result = provider.search(
         {"uri": ["spotify:track:abc", "spotify:track:abc"]}
@@ -52,8 +51,8 @@ def test_search_by_multiple_uris(session_mock, sp_track_mock, provider):
     assert track.bitrate == 160
 
 
-def test_search_when_offline_returns_nothing(session_mock, provider, caplog):
-    session_mock.connection.state = spotify.ConnectionState.OFFLINE
+def test_search_when_offline_returns_nothing(web_client_mock, provider, caplog):
+    web_client_mock.logged_in = False
 
     result = provider.search({"any": ["ABBA"]})
 
@@ -184,13 +183,12 @@ def test_sets_api_limit_to_track_count_when_max(
 
 
 def test_sets_types_parameter(
-    web_client_mock, web_search_mock_large, provider, config, session_mock
+    web_client_mock, web_search_mock_large, provider, config
 ):
     web_client_mock.get.return_value = web_search_mock_large
 
     search.search(
         config["spotify"],
-        session_mock,
         web_client_mock,
         {"any": ["ABBA"]},
         types=["album", "artist"],

